pkg_check_modules(GLIB glib-2.0)
pkg_check_modules(TIZEN vconf)

EFL_OPTION(ENABLE_GLIB "Whenever to integrate with Glib" ${GLIB_FOUND} DEPENDS GLIB_FOUND OFF)

EFL_OPTION(ENABLE_GLIB_ALWAYS "Always integrate with Glib, otheriwse needs explicit call to ecore_main_loop_glib_integrate()" OFF DEPENDS "ENABLE_GLIB" OFF)

EFL_OPTION(ENABLE_G_MAIN_LOOP "Enable ecore_main_loop based on g_main_loop" OFF DEPENDS "ENABLE_GLIB" OFF)

EFL_OPTION(ENABLE_TIZEN "Enable tizen support" OFF DEPENDS "TIZEN_FOUND" OFF)

set(ECORE_MODULE_TYPE_SYSTEM_SYSTEMD_DEFAULT ${ENABLE_SYSTEMD})
set(ECORE_MODULE_TYPE_SYSTEM_UPOWER_DEFAULT ON)
set(ECORE_MODULE_TYPE_SYSTEM_TIZEN_DEFAULT ${ENABLE_TIZEN})

# TODO libuv
# TODO gstreamer
# TODO gstreamer1

if("${BUILD_PROFILE}" STREQUAL "dev" AND HAVE_BACKTRACE)
  CHECK_APPEND_DEFINE(WANT_ECORE_TIMER_DUMP 1)
else()
  CHECK_APPEND_DEFINE(WANT_ECORE_TIMER_DUMP "")
endif()

CHECK_APPEND_DEFINE(GLIB_INTEGRATION_ALWAYS "${ENABLE_GLIB_ALWAYS}")
CHECK_APPEND_DEFINE(HAVE_GLIB "${ENABLE_GLIB}")
CHECK_APPEND_DEFINE(HAVE_TIZEN_CONFIGURATION_MANAGER "${ENABLE_TIZEN}")
CHECK_APPEND_DEFINE(USE_G_MAIN_LOOP "${ENABLE_G_MAIN_LOOP}")

FUNC_CHECK(epoll_create NAME HAVE_EPOLL INCLUDE_FILES sys/epoll.h)
FUNC_CHECK(execvp INCLUDE_FILES unistd.h)
FUNC_CHECK(gettimeofday INCLUDE_FILES sys/time.h)
FUNC_CHECK(isfinite INCLUDE_FILES math.h LIBRARIES m)
FUNC_CHECK(pause INCLUDE_FILES unistd.h)
FUNC_CHECK(timerfd_create INCLUDE_FILES sys/timerfd.h)

HEADER_CHECK(ieeefp.h)
HEADER_CHECK(langinfo.h)
HEADER_CHECK(sys/epoll.h)
HEADER_CHECK(sys/timerfd.h)
HEADER_CHECK(sys/wait.h)
